#include <avr/io.h>
#define F_CPU 16000000
#include <stdio.h>
#include <util/delay.h>
#include "usart.h"

int main()
{	
    USART0_init();
	
	DDRD |= (1 << PD7); // LED
	DDRD |= (1 << PD2); // out motor 1
	DDRD |= (1 << PD3); // out motor 1
	DDRD |= (1 << PD4); // out motor 2 (directie)
	DDRD |= (1 << PD5); // out motor 2 (directie)
	
	
	while (1) {
		char c = USART0_receive();
		
		switch(c) {
		case 'w': // Move forward
			PORTD &= ~(1 << PD3);
			_delay_ms(100);
			PORTD |= (1 << PD2);
			break;
		case 'q': // Move forward - left
			PORTD &= ~(1 << PD3);			
			PORTD &= ~(1 << PD4);

			_delay_ms(100);
			PORTD |= (1 << PD2);
			PORTD |= (1 << PD5);
			break;
		case 'e': // Move forward - right
			PORTD &= ~(1 << PD3);
			PORTD &= ~(1 << PD5);
			
			_delay_ms(100);
			PORTD |= (1 << PD2);
			PORTD |= (1 << PD4);
			break;
		case 'x': // Move backward
			PORTD &= ~(1 << PD2);
			_delay_ms(100);
			PORTD |= (1 << PD3);
			break;
		case 'z': // Move backward - left
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD4);
			
			_delay_ms(100);
			PORTD |= (1 << PD3);
			PORTD |= (1 << PD5);
			break;
		case 'c': // Move backward - right
			PORTD &= ~(1 << PD2);			
			PORTD &= ~(1 << PD5);
			
			_delay_ms(100);
			PORTD |= (1 << PD3);
			PORTD |= (1 << PD4);
			break;
		case 'a': // Move left
			PORTD &= ~(1 << PD4);
			_delay_ms(100);
			PORTD |= (1 << PD5);
			break;
		case 'd': // Move right
			PORTD &= ~(1 << PD5);
			_delay_ms(100);
			PORTD |= (1 << PD4);
			break;
		case '0': // Stop both motors
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD3);
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			break;
		default: // Stop both motors
			PORTD &= ~(1 << PD2);
			PORTD &= ~(1 << PD3);
			PORTD &= ~(1 << PD4);
			PORTD &= ~(1 << PD5);
			break;
		}
	}
		
    return 0;
}